/* Metronome V3.1
 *  Last Updated: 09-06-21
 *  Time - working
 *  Beep - working
 *  Screen - working
 *  Lights - working
 *  Power - working
 *  Menu selection working
 */
 
#include <stdint.h>  
#include <SPI.h>  
#include <OneButton.h>  
#include <Rotary.h>  
Rotary r = Rotary(3, 2);  
OneButton button(A0,true);  

 // Create IC2 object 
#include <Wire.h>
#include <LiquidCrystal_I2C.h>
LiquidCrystal_I2C lcd(0x3F,20,4);

// Create a neopixel object.
#include <Adafruit_NeoPixel.h>
Adafruit_NeoPixel strip = Adafruit_NeoPixel(4, 10, NEO_GRB + NEO_KHZ800);

// Create a DS1302 object.
#include <DS1302.h>
DS1302 rtc(6, 7, 8);

int menuNumber;
int btnState;
int save_volume;
int save_tempo;
int save_lights;
int save_sounds;
int save_hours;
int save_minutes;
int counter;
char playit;
int lightDisplayWait;
int duration;
int frequency;
unsigned char result;
char menuTempo,menuSounds,menuSubDivision,menuHours,menuMinutes;

 void setup() 
 {   
  Serial.begin(9600);
  
   pinMode (2,INPUT);
   pinMode (3,INPUT);  
   pinMode (10,OUTPUT);
   pinMode (5,OUTPUT); 

  // Initialize a new chip by turning off write protection and clearing the
  // clock halt flag. These methods needn't always be called. See the DS1302
  // datasheet for details.
  rtc.writeProtect(false);
  rtc.halt(false);
    
   menuNumber = 0;

  // initialize neopixel 
  strip.begin();
  
  // initialize the lcd 
  lcd.init();
  lcd.backlight();
  lcd.clear();
  lcd.setCursor(2,1);
  lcd.print("Metronome V3.1");
  delay(3000);
  lcd.clear();
  save_tempo = 67;
  save_volume = 20;
  save_lights = 2;
  save_sounds = 2;
  menuNumber = 1;
  lightDisplayWait = 1000;
  frequency = 1000;
  duration = 100;
  playit = 'Y';   
  menuTempo = '>';
  menuSounds = ' ';
  menuSubDivision = ' ';
  menuHours = ' ';
  menuMinutes = ':';
  // Setup Time and date, only required on first setup
  // Not worrying about date or day.
  //Time t(2021, 2, 21, 15, 55, 00, Time::kThursday);
//  rtc.time(t);
   
   //rotory interrupt  
   PCICR |= (1 << PCIE2);  
   PCMSK2 |= (1 << PCINT18) | (1 << PCINT19);  
   sei();  
   // click on the encoder  
   button.attachClick(singleclick); 

// Get current time
  Time t = rtc.time();  
  save_hours = t.hr;
  save_minutes = t.min;
 } 

 void loop() 
 { 
  lcd.setCursor(0,0);
  lcd.print(menuTempo);
  lcd.print("Tempo: ");
  lcd.print(save_tempo);
  if (save_tempo < 100 )
  {
    lcd.print(" ");
  }
  // Display current time
  showTime();
  // Display current tempo
  display_tempo(); 
  // Display current sounds value
  sounds();    
  // Display current lights value
  lights(); 
  // Play sounds and display lights
  if (playit == 'Y')
  {
    play();
  }
  btnState = analogRead(A0);
  if (btnState < 100)
  {
    playit = 'N';
  }
  // keep watching the push button:  
  button.tick();  
}

void checkbuttonpress()
{
  btnState = analogRead(A0);
  // keep watching the push button:  
  button.tick();  
}
void play()
{
     // Delay time calculated as: 60000 milliseconds = 60 seconds = 1 minute
     // Tempo for example 67 beats per minute therefore 60000 / 67 = 895.5 
     // Therefore 1 beat every 895.5 milliseconds, or 896 rounded.
     // However we must remove 100 milliseconds as this is the time taken
     // for the sound to play.
     
     lightDisplayWait = (60000 / save_tempo) - 100; 
   switch (save_lights)
   {
      case 1:
          //lcd.print("OFF    "); 
          // Still need to process sound.
           playTone(1);  
           processlightDisplayWait(lightDisplayWait);  
                   
           playTone(2);  
           processlightDisplayWait(lightDisplayWait); 

           playTone(3);  
           processlightDisplayWait(lightDisplayWait); 

           playTone(4);  
           processlightDisplayWait(lightDisplayWait); 
      break;
      case 2:
          //lcd.print("G G G G");
          // Lights flash from left to right so positions are
          // Leftmost light = 3, then 2, 1, and rightmost light 0 
           strip.setPixelColor(3,strip.Color( 150, 0, 0 ) ); //Green           
           strip.show();
           playTone(1);  
           processlightDisplayWait(lightDisplayWait);
           strip.setPixelColor(3,strip.Color( 0, 0, 0 ) ); // off
           strip.show(); 
                              
           strip.setPixelColor(2,strip.Color( 150, 0, 0 ) ); //Green
           strip.show();
           playTone(2); 
           processlightDisplayWait(lightDisplayWait);
           strip.setPixelColor(2,strip.Color( 0, 0, 0 ) ); // off
           strip.show();
                    
           strip.setPixelColor(1,strip.Color( 150, 0, 0 ) ); //Green
           strip.show();                  
           playTone(3);             
           processlightDisplayWait(lightDisplayWait);
           strip.setPixelColor(1, strip.Color( 0, 0, 0 ) ); // off
           strip.show(); 
                                       
           strip.setPixelColor(0,strip.Color( 150, 0, 0 ) ); //Green
           strip.show();                  
           playTone(4);              
           processlightDisplayWait(lightDisplayWait);
           strip.setPixelColor(0, strip.Color( 0, 0, 0 ) ); // off
           strip.show();
                                                                      
      break;
      case 3:
          //lcd.print("G G G R");
           strip.setPixelColor(3,strip.Color( 150, 0, 0 ) ); //Green           
           strip.show();
           playTone(1);  
           processlightDisplayWait(lightDisplayWait);
           strip.setPixelColor(3,strip.Color( 0, 0, 0 ) ); // off
           strip.show(); 
                                 
           strip.setPixelColor(2,strip.Color( 150, 0, 0 ) ); //Green
           strip.show();
           playTone(2); 
           processlightDisplayWait(lightDisplayWait);
           strip.setPixelColor(2,strip.Color( 0, 0, 0 ) ); // off
           strip.show();
                      
           strip.setPixelColor(1,strip.Color( 150, 0, 0 ) ); //Green
           strip.show();                  
           playTone(3);             
           processlightDisplayWait(lightDisplayWait);
           strip.setPixelColor(1, strip.Color( 0, 0, 0 ) ); // off
           strip.show(); 
                                          
           strip.setPixelColor(0,strip.Color( 150, 150, 0 ) ); //Red
           strip.show();                  
           playTone(4);              
           processlightDisplayWait(lightDisplayWait);
           strip.setPixelColor(0, strip.Color( 0, 0, 0 ) ); // off
           strip.show();
      break;
      case 4:
          //lcd.print("G R G R");
           strip.setPixelColor(3,strip.Color( 150, 0, 0 ) ); //Green           
           strip.show();
           playTone(1);  
           processlightDisplayWait(lightDisplayWait);
           strip.setPixelColor(3,strip.Color( 0, 0, 0 ) ); // off
           strip.show(); 
                                 
           strip.setPixelColor(2,strip.Color( 0, 150, 0 ) ); //Red
           strip.show();
           playTone(2); 
           processlightDisplayWait(lightDisplayWait);
           strip.setPixelColor(2,strip.Color( 0, 0, 0 ) ); // off
           strip.show();
                      
           strip.setPixelColor(1,strip.Color( 150, 0, 0 ) ); //Green
           strip.show();                  
           playTone(3);             
           processlightDisplayWait(lightDisplayWait);
           strip.setPixelColor(1, strip.Color( 0, 0, 0 ) ); // off
           strip.show(); 
                                          
           strip.setPixelColor(0,strip.Color( 0, 150, 0 ) ); //Red
           strip.show();                  
           playTone(4);              
           processlightDisplayWait(lightDisplayWait);
           strip.setPixelColor(0, strip.Color( 0, 0, 0 ) ); // off
           strip.show();
      break;
      case 5:
          //lcd.print("G G R G");
           strip.setPixelColor(3,strip.Color( 150, 0, 0 ) ); //Green           
           strip.show();
           playTone(1);  
           processlightDisplayWait(lightDisplayWait);
           strip.setPixelColor(3,strip.Color( 0, 0, 0 ) ); // off
           strip.show(); 
                                 
           strip.setPixelColor(2,strip.Color( 150, 0, 0 ) ); //Green
           strip.show();
           playTone(2); 
           processlightDisplayWait(lightDisplayWait);
           strip.setPixelColor(2,strip.Color( 0, 0, 0 ) ); // off
           strip.show();
                      
           strip.setPixelColor(1,strip.Color( 0, 150, 0 ) ); //Red
           strip.show();                 
           playTone(3);             
           processlightDisplayWait(lightDisplayWait);
           strip.setPixelColor(1, strip.Color( 0, 0, 0 ) ); // off
           strip.show(); 
                                          
           strip.setPixelColor(0,strip.Color( 150, 0, 0 ) ); //Green
           strip.show();                  
           playTone(4);              
           processlightDisplayWait(lightDisplayWait);
           strip.setPixelColor(0, strip.Color( 0, 0, 0 ) ); // off
           strip.show();
      break;
      case 6:
          //lcd.print("- - - R");
           playTone(1);  
           processlightDisplayWait(lightDisplayWait);
           
           playTone(2); 
           processlightDisplayWait(lightDisplayWait);
                                       
           playTone(3);             
           processlightDisplayWait(lightDisplayWait);
                                          
           strip.setPixelColor(0,strip.Color( 0, 150, 0 ) ); //Red
           strip.show();                  
           playTone(4);              
           processlightDisplayWait(lightDisplayWait);
           strip.setPixelColor(0, strip.Color( 0, 0, 0 ) ); // off
           strip.show();
      break;                  
      case 7:
          //lcd.print("- - R -");
           playTone(1);  
           processlightDisplayWait(lightDisplayWait);
                                 
           playTone(2); 
           processlightDisplayWait(lightDisplayWait);
                      
           strip.setPixelColor(1,strip.Color( 0, 150, 0 ) ); //Red
           strip.show();                  
           playTone(3);             
           processlightDisplayWait(lightDisplayWait);
           strip.setPixelColor(1, strip.Color( 0, 0, 0 ) ); // off
           strip.show(); 
                
           playTone(4);              
           processlightDisplayWait(lightDisplayWait);
      break;
      case 8:
          //lcd.print("- R - R");

           playTone(1);  
           processlightDisplayWait(lightDisplayWait);
                                 
           strip.setPixelColor(2,strip.Color( 0, 150, 0 ) ); //Red
           strip.show();
           playTone(2); 
           processlightDisplayWait(lightDisplayWait);
           strip.setPixelColor(2,strip.Color( 0, 0, 0 ) ); // off
           strip.show();
                                       
           playTone(3);             
           processlightDisplayWait(lightDisplayWait);
                                          
           strip.setPixelColor(0,strip.Color( 0, 150, 0 ) ); //Red
           strip.show();                  
           playTone(4);              
           processlightDisplayWait(lightDisplayWait);
           strip.setPixelColor(0, strip.Color( 0, 0, 0 ) ); // off
           strip.show();
      break;  
      case 9:
          //lcd.print("- - - G");
           playTone(1);  
           processlightDisplayWait(lightDisplayWait);
                                 
           playTone(2); 
           processlightDisplayWait(lightDisplayWait);
                                       
           playTone(3);             
           processlightDisplayWait(lightDisplayWait);
                                          
           strip.setPixelColor(0,strip.Color( 150, 0, 0 ) ); //Green
           strip.show();                  
           playTone(4);              
           processlightDisplayWait(lightDisplayWait);
           strip.setPixelColor(0, strip.Color( 0, 0, 0 ) ); // off
           strip.show();
      break;        
   }
}

void processlightDisplayWait(int howLong)
{
    delay(howLong);   
}
void playTone(int pos)
{
  switch(save_sounds)
  {
  case 1:
      //No Sounds
      if (pos == 1 || pos == 2 || pos == 3 || pos == 4 )
      {
              tone( 5, 0, 100);
      }
  break;
  case 2:
      //lcd.print("x x x .");
      if (pos == 1 || pos == 2 || pos == 3 )
      {
              tone( 5, 0, 100);
      } else 
      {
              tone( 5, 1000, 100);        
      }
  break;    
  case 3:
      //lcd.print("x . x .");
      if (pos == 1 || pos == 3 )
      {
              tone( 5, 0, 100);
      } else 
      {
              tone( 5, 1000, 100);        
      }
  break;    
  case 4:
      //lcd.print(". . . .");
      tone( 5, 1000, 100);  
  break;    
  case 5:
      //lcd.print(". . . -");
      if (pos == 1 || pos == 2 || pos == 3)
      {
              tone( 5, 1000, 100);
      } else 
      {
              tone( 5, 2000, 100);        
      }
  break;
  case 6:
      //lcd.print(". - . -");                  
      if (pos == 1 || pos == 3)
      {
              tone( 5, 1000, 100);
      } else 
      {
              tone( 5, 2000, 100);        
      }
  break;
  case 7:
      //lcd.print(". . - .");
      if (pos == 1 || pos == 2 || pos == 4)
      {
              tone( 5, 1000, 100);
      } else 
      {
              tone( 5, 2000, 100);        
      }      
  break;
  case 8:
      //lcd.print(". - . .");  
      if (pos == 1 || pos == 3 || pos == 4)
      {
              tone( 5, 1000, 100);
      } else 
      {
              tone( 5, 2000, 100);        
      }      
  break;
  case 9:
      //lcd.print("x x x -"); 
      if (pos == 1 || pos == 2 || pos == 3)
      {
              tone( 5, 0, 100);
      } else 
      {
              tone( 5, 2000, 100);        
      }           
  break;
  } 
}    

// Working Functions

void check_counter()
{
   switch (menuNumber)
   {     
    case 1: //Tempo
          if (counter < 20 )
          {
            counter = 20;
          }
          if (counter > 250 )
          {
            counter = 250;
          }
    break;
    case 2: // Sound Format
          if (counter < 1)
          {
            counter = 1;
          }
          if (counter > 9)
          {            
            counter = 9;
          } 
    break;
    case 3: // Light Format
          if (counter < 1)
          {
            counter = 1;
          }
          if (counter > 9)
          {            
            counter = 9;
          }    
    break;
    case 4: // Time Hours
          if (counter < 0)
          {
            counter = 0;
          }
          if (counter > 23 )
          {
            counter = 23;
          }
    break;
    case 5: // Time Minutes
          if (counter < 0)
          {
            counter = 0;
          }
          if (counter > 59 )
          {
            counter = 59;
          }
    break;
   }
}

void display_tempo()
{
   lcd.setCursor(0,1);
   lcd.print("                    ");
   lcd.setCursor(1,1);
   switch (save_tempo)
   {
      case 20 ... 24:
          lcd.print("Larghissimo");
      break;
      case 25 ... 40:
          lcd.print("Grave");
      break;
      case 41 ... 60:
          lcd.print("Largo");
      break;
      case 61 ... 66:
          lcd.print("Larghetto");
      break;
      case 67 ... 72:
          lcd.print("Adagio");
      break;
      case 73 ... 80:
          lcd.print("Adagietto");
      break;
      case 81 ... 92:
          lcd.print("Andantino");
      break;
      case 93 ... 108:
          lcd.print("Andantino Moderato");
      break;
      case 109 ... 112:
          lcd.print("Moderato");
      break;
      case 113 ... 120:
          lcd.print("Allegretto");
      break;
      case 121 ... 168:
          lcd.print("Allegro");
      break;
      case 169 ... 172:
          lcd.print("Vivace");
      break;            
      case 173 ... 176:
          lcd.print("Vivacissimo");
      break;
      case 177 ... 200:
          lcd.print("Presto");
      break;
      case 201 ... 250:
          lcd.print("Prestissimo");
      break;               
   }
}
void display_light_format()
{
   switch (save_lights)
   {
      case 1:
          lcd.print("OFF    ");
      break;
      case 2:
          lcd.print("G G G G");
      break;
      case 3:
          lcd.print("G G G R");
      break;
      case 4:
          lcd.print("G R G R");
      break;
      case 5:
          lcd.print("G G R G");
      break;
      case 6:
          lcd.print("- - - R");
      break;                  
      case 7:
          lcd.print("- - R -");
      break;
      case 8:
          lcd.print("- R - R");
      break;  
      case 9:
          lcd.print("- - - G");
      break;        
   }
}
void display_sound_format()
{
   switch (save_sounds)
   {
      case 1:
          lcd.print("OFF    ");
      break;
      case 2:
          lcd.print("x x x .");
      break;
      case 3:
          lcd.print("x . x .");
      break;
      case 4:
          lcd.print(". . . .");
      break;
      case 5:
          lcd.print(". . . -");
      break;
      case 6:
          lcd.print(". - . -");
      break;                  
      case 7:
          lcd.print(". . - .");
      break;
      case 8:
          lcd.print(". - . .");
      break;  
      case 9:
          lcd.print("x x x -");
      break;    
   }  
}

ISR(PCINT2_vect) 
 {  
   switch (menuNumber)
   {
         case 1:
            counter = save_tempo;
            break;
         case 2:    
            counter = save_sounds;
            break;
         case 3:
            counter = save_lights;
            break;
         case 4:    
            counter = save_hours;
            break;
         case 5:    
            counter = save_minutes;
            break;            

   }  
   result = r.process();  
   if (result == DIR_NONE) 
   {  
     // do nothing  
   }  
   else if (result == DIR_CW) 
   { 
     counter ++;   
   }  
   else
       {if (result == DIR_CCW) 
       {
         counter --;  
       }
   }
   check_counter();
   menuTempo = ' ';
   menuSounds = ' ';
   menuSubDivision = ' ';
   menuHours = ' ';
   menuMinutes = ':';
   switch (menuNumber)
   {
         case 1:
            menuTempo = '>';
            save_tempo = counter;
            break;
         case 2:    
            menuSounds = '>';
            save_sounds = counter;
            break;
         case 3:
            menuSubDivision = '>';
            save_lights = counter;
            break;
         case 4:    
            menuHours = '>';
            save_hours = counter;
            settingTime();
            break;
         case 5:    
            menuMinutes = '>';
            save_minutes = counter;
            settingTime();
            break;            
   }   
 }
 
void singleclick() 
 { 
        if ( menuNumber < 5 )
        {
          menuNumber = menuNumber + 1;
        } 
        else 
        {
          playit = 'Y';

          menuNumber = 1;  
        }    
     btnState = analogRead(A0);
        menuHours = ' ';
        menuMinutes = ':';
        menuTempo = ' ';
        menuSounds = ' ';
        menuSubDivision = ' ';
        switch(menuNumber)
        {
          case 1:
          menuTempo = '>';
          break;
          case 2:
          menuSounds = '>';
          break;
          case 3:
          menuSubDivision = '>';
          break;
          case 4:
          menuHours = '>';
          break;
          case 5:
          menuMinutes = '>';
          break;                              
        }     
 }

 void sounds()
{
   lcd.setCursor(0,2);
   lcd.print("                    ");
   lcd.setCursor(0,2);
   lcd.print(menuSounds);
   lcd.print("Sound: ");
   switch (save_sounds)
   {
      case 1:
          lcd.print("OFF    ");
      break;
      case 2:
          lcd.print("x x x .");
      break;
      case 3:
          lcd.print("x . x .");
      break;
      case 4:
          lcd.print(". . . .");
      break;
      case 5:
          lcd.print(". . . -");
      break;
      case 6:
          lcd.print(". - . -");
      break;                  
      case 7:
          lcd.print(". . - .");
      break;
      case 8:
          lcd.print(". - . .");
      break;  
      case 9:
          lcd.print("x x x -");
      break;  
   }  
}
void lights()
{
   lcd.setCursor(0,3);
   lcd.print("                    ");
   lcd.setCursor(0,3);
   lcd.print(menuSubDivision);
   lcd.print("SubDivision:");
   switch (save_lights)
   {
      case 1:
          lcd.print("OFF ");
      break;
      case 2:
           lcd.print("G G G G");                  
      break;
      case 3:
          lcd.print("G G G R");
      break;
      case 4:
          lcd.print("G R G R");
      break;
      case 5:
          lcd.print("G G R G");
      break;
      case 6:
          lcd.print("- - - R");
      break;                  
      case 7:
          lcd.print("- - R -");
      break;
      case 8:
          lcd.print("- R - R");
      break;  
      case 9:
          lcd.print("- - - G");
      break;        
   } 
}
void showTime()
{
    // Get the current time and date from the chip.
  Time t = rtc.time();  
  save_hours = t.hr;
  save_minutes = t.min;    
  lcd.setCursor(14,0);
  lcd.print(menuHours);
  if (save_hours < 10)
  {
    lcd.print("0");
  }
  lcd.print(save_hours);
  lcd.print(menuMinutes);
  if (save_minutes < 10)
  {
    lcd.print("0");
  }
  lcd.print(save_minutes); 
}

void settingTime()
{
  //Make a new time object to set the date and time.
  //Not worrying about date or day.
   Time t(2021, 1, 21, save_hours, save_minutes, 00, Time::kThursday);
  //Set the time and date on the chip.
   rtc.time(t);
   save_hours = t.hr;
   save_minutes = t.min;
}  
